<template>
  <div :class="theme" class="h-100">
    <div class="modal-header">
      <i class="vs-icon vs-dialog-cancel material-icons" @click="close()">
        close
      </i>
    </div>
    <component
      :is="component"
      v-bind="params"
      @close="close"
      @modalChangeTheme="modalChangeTheme($event)"
    />
  </div>
</template>

<script>
export default {
  props: {
    component: Object,
    params: Object,
    onClose: Function,
    canCloseByBtn: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      theme: "light"
    };
  },
  methods: {
    close(event) {
      this.onClose(event);
      this.$emit("close");
    },
    modalChangeTheme({ mode = "light" }) {
      this.theme = mode;
    }
  }
};
</script>

<style scoped>
.dark .vs-dialog-cancel {
  color: #fff;
}
</style>
